//
//  AsynchUpnpGet.m
//  uPnp2
//
//  Created by rk on 26/04/11.
//  Copyright 2011 Interchart. All rights reserved.
//

#import "AsynchUpnpGet.h"


@implementation AsynchUpnpGet

@synthesize delegate;


-(id)initWithUrl:(NSURL *)theUrl {
    self = [super init];
    url = theUrl;
    return self;
}

-(void)doGet {
    NSMutableURLRequest *request = [NSMutableURLRequest 
									requestWithURL:url 
									cachePolicy:NSURLRequestReloadIgnoringLocalAndRemoteCacheData 
									timeoutInterval:30];
	[request setHTTPMethod:@"GET"];
	[request setValue: @"1" forHTTPHeaderField:@"getContentFeatures.dlna.org"];
	[request setValue: @"getIfoFileURI.dlna.org" forHTTPHeaderField:@"Pragma"];
	[request setValue: @"Interactive" forHTTPHeaderField:@"transferMode.dlna.org"];
		
	NSLog(@"request: %@", request);
	NSLog(@"request method: %@", [request HTTPMethod]);
	NSLog(@"request headers: %@", [request allHTTPHeaderFields]);
	NSLog(@"request body:%.*s", [[request HTTPBody] length], [[request HTTPBody] bytes]);
	[readData release];
	readData = [[NSMutableData alloc] init];
	
	[[NSURLConnection alloc] initWithRequest:request
									delegate:self
							startImmediately:YES];	
	

}

#pragma mark -
#pragma mark NSURLConnection delegate
- (void)connection:(NSURLConnection *)connection didFailWithError:(NSError *)error {
	NSLog(@"%@ error: %@", self, error);
}

- (void)connection:(NSURLConnection *)connection didReceiveResponse:(NSURLResponse *)response {
	NSLog(@"%@: response:%@", self, response);
	NSHTTPURLResponse *httpResponse = (NSHTTPURLResponse *)response;
	NSLog(@"  headers: %@", [httpResponse allHeaderFields]);
}
//This method will be called several times as the data arrives
- (void) connection:(NSURLConnection *)connection didReceiveData:(NSData *)data {
	[readData appendData: data];
}

- (void) connectionDidFinishLoading:(NSURLConnection *)connection {
	NSLog(@"readData Length:'%d', ", [readData length]);	
	if ([delegate respondsToSelector:@selector(handleAsynchUpnpGetResult:)]) {
		[delegate handleAsynchUpnpGetResult:readData];
	}
    
	[readData release];
	readData = [[NSMutableData alloc] init]; // ready for next read
}

@end
