//
//  MediaServerViewController.m
//  uPnp2
//
//  Created by rk on 29/08/11.
//  Copyright 2011 Interchart. All rights reserved.
//

#import "MediaServerViewController.h"
#import "RootViewController.h"
#import "AsyncUdpSocket.h"


@implementation MediaServerViewController


- (IBAction) powerServerOff {
    NSString *url = @"http://halt:halt@192.168.0.200/halt";
    NSURLRequest *theRequest=[NSURLRequest requestWithURL:[NSURL URLWithString:url]];
    NSURLConnection *theConnection=[[NSURLConnection alloc] initWithRequest:theRequest delegate:self]; // request async, ignore response
}

- (IBAction) powerServerOn {
    NSString *ipString = @"192.168.0.255"; // 192.168.0.200 broadcast address
    NSString *hexString = @"3cd92b06d90b";
    const char *hexChars = [hexString UTF8String];
    unsigned char magicPacket[102];
    //Fill in magic packet with 102 Bytes of data
    
    //Header
    
    //fill 6 Bytes with 0xFF
    
    for (int i=0;i<6;i++) magicPacket[i] = 0xff;
    //First 6 bytes (these must be repeated!!)
    
    //fill bytes 6-12
    
    for (int i=0; i<6; i++) {
        //Get 2 characters from mac address and convert it to int to fill
        
        //magic packet
        //magicPacket[i+6] = HexStrToInt(macAddr.Mid(i*2,2));
        sscanf(hexChars + i*2, "%2x", &magicPacket[i+6]);
    }
    
    //fill remaining 90 bytes (15 time repeat)
    
    for (int i=0; i<15; i++) memcpy(&magicPacket[(i+2)*6], &magicPacket[6], 6);
    int len = sizeof(magicPacket);
    for (int i=0; i<len; i++) {
        NSLog(@"%1x", magicPacket[i]);
    }
    NSData *data = [[NSData alloc] initWithBytes:&magicPacket length:sizeof(magicPacket)];
    AsyncUdpSocket *socket = [[AsyncUdpSocket alloc] init];
    NSError *error;
    [socket enableBroadcast:true error:&error];
    [socket sendData:data toHost:ipString port:9 withTimeout:-1 tag:1]; 
    [data release];
    
//    UIPopoverController *popoverController = _popoverController;
//    [popoverController dismissPopoverAnimated:true];
}

- (id) init {
	self = [super initWithNibName:@"MediaServerView" bundle:nil];
	return self;
}


- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil
{
//    self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil];
//    if (self) {
//        // Custom initialization
//    }
//    return self;
	self = [self init];
    return self;
}

- (void)dealloc
{
    [super dealloc];
}

- (void)didReceiveMemoryWarning
{
    // Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
    
    // Release any cached data, images, etc that aren't in use.
}

#pragma mark - View lifecycle

- (void)viewDidLoad
{
    [super viewDidLoad];
    // Do any additional setup after loading the view from its nib.
}

- (void)viewDidUnload
{
    [super viewDidUnload];
    // Release any retained subviews of the main view.
    // e.g. self.myOutlet = nil;
}

- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation
{
    // Return YES for supported orientations
	return YES;
}

@end
