//
//  UpnpAvTransportService.m
//  uPnp2
//
//  Created by rk on 10/04/11.
//  Copyright 2011 Interchart. All rights reserved.
//

#import "UpnpAvTransportService.h"
#import "OrderedDictionary.h"


@implementation UpnpAvTransportService

#pragma mark Designated Initializer
-(id)initWithService:(UpnpAvService *)theService {
	self = [super init];
	service = theService;
//	desiredVolume = -1;
	return self;
}

#pragma mark AsynchUpnpCommandDelegate methods
- (void)handleAsynchUpnpCommandResult:(GDataXMLDocument *)parsedResult {
	
	if ([UpnpAvTransportService isSetAvTransportUriResponse:parsedResult]) {
        NSLog(@"Woohoo, got SetAvTransportUriResponse");
//		int currentVolume = [UpnpAvRenderingControlService getVolumeResponseValue:parsedResult];
//		if (currentVolume == desiredVolume) {
//			volumeChangeIsPending = false; // this method is only called if volume change called
//			[desiredVolumeResponseHandler handleAsynchUpnpCommandResult:parsedResult];
//			[self asynchGetMute:desiredVolumeResponseHandler];
//			
//		} else {
//			[self sendSetVolumeCommand:desiredVolume];
//		}
	}
}


#pragma mark -

- (void) asynchSetAvTransportUri:(NSString *)sUri: (id<AsynchUpnpCommandDelegate>)responseHandler { //responseHandler currently ignored
	NSLog(@"%@: asynchSetAvTransportUri, sUri='%@'", self, sUri);
	
	NSString *commandName = @"SetAVTransportURI";
	OrderedDictionary *args = [[OrderedDictionary alloc] init];
	[args setValue:@"0" forKey:@"InstanceID"];
	[args setValue:sUri forKey:@"CurrentURI"];
	[args setValue:@"" forKey:@"CurrentURIMetaData"];
	
	AsynchUpnpCommand *command = [[AsynchUpnpCommand alloc] init];
	command.command = commandName;
	command.params = args;
	command.delegate = self;
    
	[service executeCommandAsync:command];
}


- (void)asynchPlay:(UInt32)speed: (id<AsynchUpnpCommandDelegate>)responseHandler{
    NSLog(@"%@: asynchPlay, speed='%lu'", self, speed);
	
	NSString *commandName = @"Play";
	OrderedDictionary *args = [[OrderedDictionary alloc] init];
	[args setValue:@"0" forKey:@"InstanceID"];
	[args setValue:[NSString stringWithFormat:@"%lu", speed] forKey:@"Speed"];
	
	AsynchUpnpCommand *command = [[AsynchUpnpCommand alloc] init];
	command.command = commandName;
	command.params = args;
	command.delegate = self;
    
	[service executeCommandAsync:command];
}

- (void)asynchPause:(id<AsynchUpnpCommandDelegate>)responseHandler{
    NSLog(@"%@: asynchPause", self);
	
	NSString *commandName = @"Pause";
	OrderedDictionary *args = [[OrderedDictionary alloc] init];
	[args setValue:@"0" forKey:@"InstanceID"];
	//[args setValue:[NSString stringWithFormat:@"%lu", speed] forKey:@"Speed"];
	
	AsynchUpnpCommand *command = [[AsynchUpnpCommand alloc] init];
	command.command = commandName;
	command.params = args;
	command.delegate = self;
    
	[service executeCommandAsync:command];
}



#pragma mark Static Utility Methods
+(bool)isSetAvTransportUriResponse:(GDataXMLDocument *)parsedResult {
    NSLog(@"parsedResult:%@", parsedResult);
    NSError *error;
//    NSArray *soapBody = [parsedResult nodesForXPath:@"//soap:Envelope/soap:Body" 
//                                         namespaces:[UpnpAvService namespaceDict] 
//                                              error:&error];

    NSArray *transportResponse = [parsedResult nodesForXPath:@"//soap:Envelope/soap:Body/upnpAVT:SetAVTransportURIResponse" 
                                            namespaces:[UpnpAvService namespaceDict] 
                                                 error:&error];
	if (transportResponse) {
		return true;
	} else {
		return false;
	}
}

@end
